# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_defaultgatewayaddress`](#dsc_defaultgatewayaddress): The DSC DefaultGatewayAddress resource type. Automatically generated from version 8.2.0
* [`dsc_dnsclientglobalsetting`](#dsc_dnsclientglobalsetting): The DSC DnsClientGlobalSetting resource type. Automatically generated from version 8.2.0
* [`dsc_dnsconnectionsuffix`](#dsc_dnsconnectionsuffix): The DSC DnsConnectionSuffix resource type. Automatically generated from version 8.2.0
* [`dsc_dnsserveraddress`](#dsc_dnsserveraddress): The DSC DnsServerAddress resource type. Automatically generated from version 8.2.0
* [`dsc_firewall`](#dsc_firewall): The DSC Firewall resource type. Automatically generated from version 8.2.0
* [`dsc_firewallprofile`](#dsc_firewallprofile): The DSC FirewallProfile resource type. Automatically generated from version 8.2.0
* [`dsc_hostsfile`](#dsc_hostsfile): The DSC HostsFile resource type. Automatically generated from version 8.2.0
* [`dsc_ipaddress`](#dsc_ipaddress): The DSC IPAddress resource type. Automatically generated from version 8.2.0
* [`dsc_ipaddressoption`](#dsc_ipaddressoption): The DSC IPAddressOption resource type. Automatically generated from version 8.2.0
* [`dsc_netadapteradvancedproperty`](#dsc_netadapteradvancedproperty): The DSC NetAdapterAdvancedProperty resource type. Automatically generated from version 8.2.0
* [`dsc_netadapterbinding`](#dsc_netadapterbinding): The DSC NetAdapterBinding resource type. Automatically generated from version 8.2.0
* [`dsc_netadapterlso`](#dsc_netadapterlso): The DSC NetAdapterLso resource type. Automatically generated from version 8.2.0
* [`dsc_netadaptername`](#dsc_netadaptername): The DSC NetAdapterName resource type. Automatically generated from version 8.2.0
* [`dsc_netadapterrdma`](#dsc_netadapterrdma): The DSC NetAdapterRdma resource type. Automatically generated from version 8.2.0
* [`dsc_netadapterrsc`](#dsc_netadapterrsc): The DSC NetAdapterRsc resource type. Automatically generated from version 8.2.0
* [`dsc_netadapterrss`](#dsc_netadapterrss): The DSC NetAdapterRss resource type. Automatically generated from version 8.2.0
* [`dsc_netadapterstate`](#dsc_netadapterstate): The DSC NetAdapterState resource type. Automatically generated from version 8.2.0
* [`dsc_netbios`](#dsc_netbios): The DSC NetBios resource type. Automatically generated from version 8.2.0
* [`dsc_netconnectionprofile`](#dsc_netconnectionprofile): The DSC NetConnectionProfile resource type. Automatically generated from version 8.2.0
* [`dsc_netipinterface`](#dsc_netipinterface): The DSC NetIPInterface resource type. Automatically generated from version 8.2.0
* [`dsc_networkteam`](#dsc_networkteam): The DSC NetworkTeam resource type. Automatically generated from version 8.2.0
* [`dsc_networkteaminterface`](#dsc_networkteaminterface): The DSC NetworkTeamInterface resource type. Automatically generated from version 8.2.0
* [`dsc_proxysettings`](#dsc_proxysettings): The DSC ProxySettings resource type. Automatically generated from version 8.2.0
* [`dsc_route`](#dsc_route): The DSC Route resource type. Automatically generated from version 8.2.0
* [`dsc_waitfornetworkteam`](#dsc_waitfornetworkteam): The DSC WaitForNetworkTeam resource type. Automatically generated from version 8.2.0
* [`dsc_winsserveraddress`](#dsc_winsserveraddress): The DSC WinsServerAddress resource type. Automatically generated from version 8.2.0
* [`dsc_winssetting`](#dsc_winssetting): The DSC WinsSetting resource type. Automatically generated from version 8.2.0

## Resource types

### `dsc_defaultgatewayaddress`

The DSC DefaultGatewayAddress resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_defaultgatewayaddress` type.

##### `dsc_address`

Data type: `Optional[String]`

The desired default gateway address - if not provided default gateway will be removed.

#### Parameters

The following parameters are available in the `dsc_defaultgatewayaddress` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'IPv6']`

IP address family.

##### `dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the default gateway address is set.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_dnsclientglobalsetting`

The DSC DnsClientGlobalSetting resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_dnsclientglobalsetting` type.

##### `dsc_devolutionlevel`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of labels up to which devolution should occur.

##### `dsc_suffixsearchlist`

Data type: `Optional[Array[String]]`

Specifies a list of global suffixes that can be used in the specified order by the DNS client for resolving the IP address of the computer name.

##### `dsc_usedevolution`

Data type: `Optional[Boolean]`

Specifies that devolution is activated.

#### Parameters

The following parameters are available in the `dsc_dnsclientglobalsetting` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_dnsconnectionsuffix`

The DSC DnsConnectionSuffix resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_dnsconnectionsuffix` type.

##### `dsc_connectionspecificsuffix`

Data type: `String`

DNS connection-specific suffix to assign to the network interface.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure that the network interface connection-specific suffix is present or not.

##### `dsc_registerthisconnectionsaddress`

Data type: `Optional[Boolean]`

Specifies that the IP address for this connection is to be registered.

##### `dsc_usesuffixwhenregistering`

Data type: `Optional[Boolean]`

Specifies that this host name and the connection specific suffix for this connection are to be registered.

#### Parameters

The following parameters are available in the `dsc_dnsconnectionsuffix` type.

##### `dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the DNS server address is set.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_dnsserveraddress`

The DSC DnsServerAddress resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_dnsserveraddress` type.

##### `dsc_address`

Data type: `Optional[Array[String]]`

The desired DNS Server address(es). Exclude to enable DHCP.

#### Parameters

The following parameters are available in the `dsc_dnsserveraddress` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'IPv6']`

IP address family.

##### `dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the DNS server address is set.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_validate`

Data type: `Optional[Boolean]`

Requires that the DNS Server addresses be validated if they are updated. It will cause the resource to throw a 'A
general error occurred that is not covered by a more specific error code.' error if set to True and specified DNS
Servers are not accessible.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_firewall`

The DSC Firewall resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_firewall` type.

##### `dsc_action`

Data type: `Optional[Enum['NotConfigured', 'Allow', 'Block']]`

Allow or Block the supplied configuration.

##### `dsc_authentication`

Data type: `Optional[Enum['NotRequired', 'Required', 'NoEncap']]`

Specifies that authentication is required on firewall rules.

##### `dsc_description`

Data type: `Optional[String]`

Documentation for the Rule.

##### `dsc_direction`

Data type: `Optional[Enum['Inbound', 'Outbound']]`

Direction of the connection.

##### `dsc_displaygroup`

Data type: `Optional[String]`

The current value of the Display Group of the Firewall Rule.

##### `dsc_displayname`

Data type: `Optional[String]`

Localized, user-facing name of the Firewall Rule being created.

##### `dsc_dynamictransport`

Data type: `Optional[Enum['Any', 'ProximityApps', 'ProximitySharing', 'WifiDirectPrinting', 'WifiDirectDisplay', 'WifiDirectDevices']]`

Specifies a dynamic transport.

##### `dsc_edgetraversalpolicy`

Data type: `Optional[Enum['Block', 'Allow', 'DeferToUser', 'DeferToApp']]`

Specifies that matching firewall rules of the indicated edge traversal policy are created.

##### `dsc_enabled`

Data type: `Optional[Enum['True', 'False']]`

Enable or disable the supplied configuration.

##### `dsc_encryption`

Data type: `Optional[Enum['NotRequired', 'Required', 'Dynamic']]`

Specifies that encryption in authentication is required on firewall rules.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure the presence/absence of the resource.

##### `dsc_group`

Data type: `Optional[String]`

Name of the Firewall Group where we want to put the Firewall Rule.

##### `dsc_icmptype`

Data type: `Optional[Array[String]]`

Specifies the ICMP type codes.

##### `dsc_interfacealias`

Data type: `Optional[Array[String]]`

Specifies the alias of the interface that applies to the traffic.

##### `dsc_interfacetype`

Data type: `Optional[Enum['Any', 'Wired', 'Wireless', 'RemoteAccess']]`

Specifies that only network connections made through the indicated interface types are subject to the requirements of this rule.

##### `dsc_localaddress`

Data type: `Optional[Array[String]]`

Specifies that network packets with matching IP addresses match this rule.

##### `dsc_localonlymapping`

Data type: `Optional[Boolean]`

Indicates that matching firewall rules of the indicated value are created.

##### `dsc_localport`

Data type: `Optional[Array[String]]`

Local Port used for the filter.

##### `dsc_localuser`

Data type: `Optional[String]`

Specifies the principals to which network traffic this firewall rule applies.

##### `dsc_loosesourcemapping`

Data type: `Optional[Boolean]`

Indicates that matching firewall rules of the indicated value are created.

##### `dsc_overrideblockrules`

Data type: `Optional[Boolean]`

Indicates that matching network traffic that would otherwise be blocked are allowed.

##### `dsc_owner`

Data type: `Optional[String]`

Specifies that matching firewall rules of the indicated owner are created.

##### `dsc_package`

Data type: `Optional[String]`

Specifies the Windows Store application to which the firewall rule applies.

##### `dsc_platform`

Data type: `Optional[Array[String]]`

Specifies which version of Windows the associated rule applies.

##### `dsc_profile`

Data type: `Optional[Array[String]]`

Specifies one or more profiles to which the rule is assigned.

##### `dsc_program`

Data type: `Optional[String]`

Path and file name of the program for which the rule is applied.

##### `dsc_protocol`

Data type: `Optional[String]`

Specific Protocol for filter. Specified by name, number, or range.

##### `dsc_remoteaddress`

Data type: `Optional[Array[String]]`

Specifies that network packets with matching IP addresses match this rule.

##### `dsc_remotemachine`

Data type: `Optional[String]`

Specifies that matching IPsec rules of the indicated computer accounts are created.

##### `dsc_remoteport`

Data type: `Optional[Array[String]]`

Specific Port used for filter. Specified by port number, range, or keyword

##### `dsc_remoteuser`

Data type: `Optional[String]`

Specifies that matching IPsec rules of the indicated user accounts are created.

##### `dsc_service`

Data type: `Optional[String]`

Specifies the short name of a Windows service to which the firewall rule applies.

#### Parameters

The following parameters are available in the `dsc_firewall` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the Firewall Rule.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_firewallprofile`

The DSC FirewallProfile resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_firewallprofile` type.

##### `dsc_allowinboundrules`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies that the firewall blocks inbound traffic.

##### `dsc_allowlocalfirewallrules`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies that the local firewall rules should be merged into the effective policy along with Group Policy settings.

##### `dsc_allowlocalipsecrules`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies that the local IPsec rules should be merged into the effective policy along with Group Policy settings.

##### `dsc_allowunicastresponsetomulticast`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Allows unicast responses to multi-cast traffic.

##### `dsc_allowuserapps`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies that traffic from local user applications is allowed through the firewall.

##### `dsc_allowuserports`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies that traffic is allowed through local user ports.

##### `dsc_defaultinboundaction`

Data type: `Optional[Enum['Block', 'Allow', 'NotConfigured']]`

Specifies how to filter inbound traffic.

##### `dsc_defaultoutboundaction`

Data type: `Optional[Enum['Block', 'Allow', 'NotConfigured']]`

Specifies how to filter outbound traffic.

##### `dsc_disabledinterfacealiases`

Data type: `Optional[Array[String]]`

Specifies a list of interfaces on which firewall settings are excluded.

##### `dsc_enabled`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies that devolution is activated.

##### `dsc_enablestealthmodeforipsec`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Enables stealth mode for IPsec traffic.

##### `dsc_logallowed`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies how to log the allowed packets in the location specified by the LogFileName parameter.

##### `dsc_logblocked`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies how to log the dropped packets in the location specified by the LogFileName parameter.

##### `dsc_logfilename`

Data type: `Optional[String]`

Specifies the path and filename of the file to which Windows Server writes log entries.

##### `dsc_logignored`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Specifies how to log the ignored packets in the location specified by the LogFileName parameter.

##### `dsc_logmaxsizekilobytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the maximum file size of the log, in kilobytes. The acceptable values for this parameter are: 1 through 32767.

##### `dsc_notifyonlisten`

Data type: `Optional[Enum['True', 'False', 'NotConfigured']]`

Allows the notification of listening for inbound connections by a service.

#### Parameters

The following parameters are available in the `dsc_firewallprofile` type.

##### `dsc_name`

namevar

Data type: `Enum['Domain', 'Public', 'Private']`

The name of the firewall profile to configure.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_hostsfile`

The DSC HostsFile resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_hostsfile` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the hosts file entry should be created or deleted.

##### `dsc_ipaddress`

Data type: `Optional[String]`

Specifies the IP Address that should be mapped to the host name.

#### Parameters

The following parameters are available in the `dsc_hostsfile` type.

##### `dsc_hostname`

namevar

Data type: `String`

Specifies the name of the computer that will be mapped to an IP address.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_ipaddress`

The DSC IPAddress resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_ipaddress` type.

##### `dsc_ipaddress`

Data type: `Optional[Array[String]]`

The desired IP address, optionally including prefix length using CIDR notation.

##### `dsc_keepexistingaddress`

Data type: `Optional[Boolean]`

Indicates whether or not existing IP addresses on an interface will be retained.

#### Parameters

The following parameters are available in the `dsc_ipaddress` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'IPv6']`

IP address family.

##### `dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the IP address should be set.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_ipaddressoption`

The DSC IPAddressOption resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_ipaddressoption` type.

##### `dsc_skipassource`

Data type: `Optional[Boolean]`

Skip as source option of the ip address.

#### Parameters

The following parameters are available in the `dsc_ipaddressoption` type.

##### `dsc_ipaddress`

namevar

Data type: `String`

The target IP address, must already be configured on the system.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadapteradvancedproperty`

The DSC NetAdapterAdvancedProperty resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadapteradvancedproperty` type.

##### `dsc_displayvalue`

Data type: `Optional[String]`

Output Display value of selected RegistryKeyword.

##### `dsc_registryvalue`

Data type: `String`

Specifies the value of the registry keyword.

#### Parameters

The following parameters are available in the `dsc_netadapteradvancedproperty` type.

##### `dsc_networkadaptername`

namevar

Data type: `String`

Specifies the name of the network adapter to set the advanced property for.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_registrykeyword`

namevar

Data type: `String`

Specifies the registry keyword that should be in desired state.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadapterbinding`

The DSC NetAdapterBinding resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadapterbinding` type.

##### `dsc_currentstate`

Data type: `Optional[Enum['Enabled', 'Disabled', 'Mixed']]`

Returns the current state of the component ID for the Interfaces.

##### `dsc_state`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies if the component ID for the Interface should be Enabled or Disabled.

#### Parameters

The following parameters are available in the `dsc_netadapterbinding` type.

##### `dsc_componentid`

namevar

Data type: `String`

Specifies the underlying name of the transport or filter in the following form - ms_xxxx, such as ms_tcpip.

##### `dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias of a network interface. Supports the use of '*'.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadapterlso`

The DSC NetAdapterLso resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadapterlso` type.

##### `dsc_protocol`

Data type: `Enum['V1IPv4', 'IPv4', 'IPv6']`

Specifies which protocol to make changes to.

##### `dsc_state`

Data type: `Boolean`

Specifies whether LSO should be enabled or disabled.

#### Parameters

The following parameters are available in the `dsc_netadapterlso` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of network adapter.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadaptername`

The DSC NetAdapterName resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadaptername` type.

##### `dsc_driverdescription`

Data type: `Optional[String]`

This is the driver description of the network adapter.

##### `dsc_ignoremultiplematchingadapters`

Data type: `Optional[Boolean]`

This switch will suppress an error occurring if more than one matching adapter matches the parameters passed.

##### `dsc_interfacedescription`

Data type: `Optional[String]`

This is the interface description of the network adapter to find.

##### `dsc_interfaceguid`

Data type: `Optional[String]`

This is the interface GUID of the network adapter to find.

##### `dsc_interfaceindex`

Data type: `Optional[Integer[0, 4294967295]]`

This is the interface index of the network adapter to find.

##### `dsc_interfacenumber`

Data type: `Optional[Integer[0, 4294967295]]`

This is the interface number of the network adapter if more than one are returned by the parameters.

##### `dsc_macaddress`

Data type: `Optional[String]`

This is the MAC address of the network adapter to find.

##### `dsc_name`

Data type: `Optional[String]`

This is the name of the network adapter to find.

##### `dsc_physicalmediatype`

Data type: `Optional[String]`

This is the media type of the network adapter to find.

##### `dsc_status`

Data type: `Optional[Enum['Up', 'Disconnected', 'Disabled']]`

This is the status of the network adapter to find.

#### Parameters

The following parameters are available in the `dsc_netadaptername` type.

##### `dsc_newname`

namevar

Data type: `String`

Specifies the new name of the network adapter.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadapterrdma`

The DSC NetAdapterRdma resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadapterrdma` type.

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Specifies if the RDMA configuration should be enabled or disabled. Defaults to $true.

#### Parameters

The following parameters are available in the `dsc_netadapterrdma` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of network adapter for which RDMA needs to be configured.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadapterrsc`

The DSC NetAdapterRsc resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadapterrsc` type.

##### `dsc_protocol`

Data type: `Enum['IPv4', 'IPv6', 'All']`

Specifies which protocol to make changes to.

##### `dsc_state`

Data type: `Boolean`

Specifies whether RSC should be enabled or disabled.

##### `dsc_stateipv4`

Data type: `Optional[String]`

Returns the current state of RSC for IPv4

##### `dsc_stateipv6`

Data type: `Optional[String]`

Returns the current state of RSC for IPv6

#### Parameters

The following parameters are available in the `dsc_netadapterrsc` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the Name of network adapter.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadapterrss`

The DSC NetAdapterRss resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadapterrss` type.

##### `dsc_enabled`

Data type: `Boolean`

Specifies whether RSS should be enabled or disabled.

#### Parameters

The following parameters are available in the `dsc_netadapterrss` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the Name of network adapter.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netadapterstate`

The DSC NetAdapterState resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netadapterstate` type.

##### `dsc_state`

Data type: `Enum['Enabled', 'Disabled']`

Specifies the desired state of the network adapter

#### Parameters

The following parameters are available in the `dsc_netadapterstate` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of network adapter.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netbios`

The DSC NetBios resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netbios` type.

##### `dsc_setting`

Data type: `Enum['Default', 'Enable', 'Disable']`

Specifies if NetBIOS should be enabled or disabled or obtained from the DHCP server (Default). If static IP, Enable NetBIOS.

#### Parameters

The following parameters are available in the `dsc_netbios` type.

##### `dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias of a network interface. Supports the use of '*' and '%'

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netconnectionprofile`

The DSC NetConnectionProfile resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netconnectionprofile` type.

##### `dsc_ipv4connectivity`

Data type: `Optional[Enum['Disconnected', 'NoTraffic', 'Subnet', 'LocalNetwork', 'Internet']]`

Sets the Network Category for the interface.

##### `dsc_ipv6connectivity`

Data type: `Optional[Enum['Disconnected', 'NoTraffic', 'Subnet', 'LocalNetwork', 'Internet']]`

Specifies the IPv4 Connection Value.

##### `dsc_networkcategory`

Data type: `Optional[Enum['Public', 'Private']]`

Specifies the IPv6 Connection Value.

#### Parameters

The following parameters are available in the `dsc_netconnectionprofile` type.

##### `dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias for the Interface that is being changed.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_netipinterface`

The DSC NetIPInterface resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_netipinterface` type.

##### `dsc_advertisedefaultroute`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the default router advertisement for an interface.

##### `dsc_advertising`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the router advertisement value for the IP interface.

##### `dsc_automaticmetric`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the value for automatic metric calculation.

##### `dsc_dhcp`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the Dynamic Host Configuration Protocol (DHCP) value for an IP interface.

##### `dsc_directedmacwolpattern`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the wake-up packet value for an IP interface.

##### `dsc_ecnmarking`

Data type: `Optional[Enum['Disabled', 'UseEct1', 'UseEct0', 'AppDecide']]`

Specifies the value for Explicit Congestion Notification (ECN) marking.

##### `dsc_forcearpndwolpattern`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the Wake On LAN (WOL) value for the IP interface.

##### `dsc_forwarding`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the packet forwarding value for the IP interface.

##### `dsc_ignoredefaultroutes`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies a value for Default Route advertisements.

##### `dsc_interfacemetric`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the metric for an IP interface.

##### `dsc_managedaddressconfiguration`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the value for managed address configuration.

##### `dsc_neighborunreachabilitydetection`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the value for Neighbor Unreachability Detection (NUD).

##### `dsc_nlmtu`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the network layer Maximum Transmission Unit (MTU) value, in bytes, for an IP interface.

##### `dsc_otherstatefulconfiguration`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the value for configuration other than addresses.

##### `dsc_routerdiscovery`

Data type: `Optional[Enum['Enabled', 'Disabled', 'ControlledByDHCP']]`

Specifies the value for router discovery for an IP interface.

##### `dsc_weakhostreceive`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the receive value for a weak host model.

##### `dsc_weakhostsend`

Data type: `Optional[Enum['Enabled', 'Disabled']]`

Specifies the send value for a weak host model.

#### Parameters

The following parameters are available in the `dsc_netipinterface` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'IPv6']`

IP address family on the interface to configure.

##### `dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface to configure.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_networkteam`

The DSC NetworkTeam resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_networkteam` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the network team should be created or deleted. Defaults to 'Present'.

##### `dsc_loadbalancingalgorithm`

Data type: `Optional[Enum['Dynamic', 'HyperVPort', 'IPAddresses', 'MacAddresses', 'TransportPorts']]`

Specifies the load balancing algorithm for the network team.

##### `dsc_teamingmode`

Data type: `Optional[Enum['SwitchIndependent', 'LACP', 'Static']]`

Specifies the teaming mode configuration.

##### `dsc_teammembers`

Data type: `Array[String]`

Specifies the network interfaces that should be a part of the network team. This is a comma-separated list.

#### Parameters

The following parameters are available in the `dsc_networkteam` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of the network team to create.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_networkteaminterface`

The DSC NetworkTeamInterface resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_networkteaminterface` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the network team interface should be created or deleted. Defaults to 'Present'.

##### `dsc_teamname`

Data type: `String`

Specifies the name of the network team on which this particular interface should exist.

##### `dsc_vlanid`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies VLAN ID to be set on network team interface.

#### Parameters

The following parameters are available in the `dsc_networkteaminterface` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of the network team interface to create.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_proxysettings`

The DSC ProxySettings resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_proxysettings` type.

##### `dsc_autoconfigurl`

Data type: `Optional[String]`

The URL of the automatic configuration script to specify the proxy settings. Should be specified if 'EnableAutoConfiguration' is 'True'.

##### `dsc_connectiontype`

Data type: `Optional[Enum['All', 'Default', 'Legacy']]`

Defines if the proxy settings should be configured for default connections, legacy connections or all connections. Defaults to 'All'.

##### `dsc_enableautoconfiguration`

Data type: `Optional[Boolean]`

Use automatic configuration script for specifying proxy settings. Defaults to 'False'.

##### `dsc_enableautodetection`

Data type: `Optional[Boolean]`

Enable automatic detection of the proxy settings. Defaults to 'False'.

##### `dsc_enablemanualproxy`

Data type: `Optional[Boolean]`

Use manual proxy server settings. Defaults to 'False'.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if computer proxy settings should be set. Defaults to 'Present'.

##### `dsc_proxyserver`

Data type: `Optional[String]`

The address and port of the manual proxy server to use. Should be specified if 'EnableManualProxy' is 'True'.

##### `dsc_proxyserverbypasslocal`

Data type: `Optional[Boolean]`

Bypass proxy server for local addresses. Defaults to 'False'.

##### `dsc_proxyserverexceptions`

Data type: `Optional[Array[String]]`

Bypass proxy server for addresses starting with addresses in this list.

#### Parameters

The following parameters are available in the `dsc_proxysettings` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_route`

The DSC Route resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_route` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the route should exist. Defaults to 'Present'.

##### `dsc_preferredlifetime`

Data type: `Optional[Float]`

Specifies a preferred lifetime in seconds of an IP route.

##### `dsc_publish`

Data type: `Optional[Enum['No', 'Yes', 'Age']]`

Specifies the publish setting of an IP route. Defaults to 'No'.

##### `dsc_routemetric`

Data type: `Optional[Integer[0, 65535]]`

Specifies an integer route metric for an IP route. Defaults to 256.

#### Parameters

The following parameters are available in the `dsc_route` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'IPv6']`

Specifies the IP address family.

##### `dsc_destinationprefix`

namevar

Data type: `String`

Specifies a destination prefix of an IP route. A destination prefix consists of an IP address prefix and a prefix
length, separated by a slash (/).

##### `dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias of a network interface.

##### `dsc_nexthop`

namevar

Data type: `String`

Specifies the next hop for the IP route.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_waitfornetworkteam`

The DSC WaitForNetworkTeam resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_waitfornetworkteam` type.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

The number of times to loop the retry interval while waiting for the network team.

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of seconds to wait for the network team to become available.

#### Parameters

The following parameters are available in the `dsc_waitfornetworkteam` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of the network team to wait for.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_winsserveraddress`

The DSC WinsServerAddress resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_winsserveraddress` type.

##### `dsc_address`

Data type: `Optional[Array[String]]`

The desired WINS Server address(es). Exclude to remove all WINS servers.

#### Parameters

The following parameters are available in the `dsc_winsserveraddress` type.

##### `dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the WINS server address is set.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_winssetting`

The DSC WinsSetting resource type.
Automatically generated from version 8.2.0

#### Properties

The following properties are available in the `dsc_winssetting` type.

##### `dsc_enabledns`

Data type: `Optional[Boolean]`

Specifies if DNS is enabled for name resolution over WINS for all network adapters with TCP/IP enabled.

##### `dsc_enablelmhosts`

Data type: `Optional[Boolean]`

Specifies if LMHOSTS lookup should be enabled for all network adapters with TCP/IP enabled.

#### Parameters

The following parameters are available in the `dsc_winssetting` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

