require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_netadapteradvancedproperty',
  dscmeta_resource_friendly_name: 'NetAdapterAdvancedProperty',
  dscmeta_resource_name: 'DSC_NetAdapterAdvancedProperty',
  dscmeta_module_name: 'NetworkingDsc',
  dscmeta_module_version: '8.2.0',
  docs: 'The DSC NetAdapterAdvancedProperty resource type.
         Automatically generated from version 8.2.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_networkadaptername: {
      type: 'String',
      desc: 'Specifies the name of the network adapter to set the advanced property for.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_registrykeyword: {
      type: 'String',
      desc: 'Specifies the registry keyword that should be in desired state.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_displayvalue: {
      type: 'Optional[String]',
      desc: 'Output Display value of selected RegistryKeyword.',
      behaviour: :read_only,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_registryvalue: {
      type: 'String',
      desc: 'Specifies the value of the registry keyword.',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
