require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_winsserveraddress',
  dscmeta_resource_friendly_name: 'WinsServerAddress',
  dscmeta_resource_name: 'DSC_WinsServerAddress',
  dscmeta_module_name: 'NetworkingDsc',
  dscmeta_module_version: '8.2.0',
  docs: 'The DSC WinsServerAddress resource type.
         Automatically generated from version 8.2.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_interfacealias: {
      type: 'String',
      desc: 'Alias of the network interface for which the WINS server address is set.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_address: {
      type: 'Optional[Array[String]]',
      desc: 'The desired WINS Server address(es). Exclude to remove all WINS servers.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
  },
)
